var $4mxld$jsxpragmatic = require("jsx-pragmatic");
var $4mxld$zoid = require("zoid");

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
function $parcel$interopDefault(a) {
  return a && a.__esModule ? a.default : a;
}

$parcel$export(module.exports, "Notabene", () => $fef5d623a19b12b5$export$2e2bcd8739ae039);


class $fef5d623a19b12b5$export$2e2bcd8739ae039 {
    constructor(config){
        this.config = config;
        this.theme = this.config.theme;
        this.dictionary = this.config.dictionary;
        this.widget = this.buildWidget();
        this.popup = this.buildPopup();
        this.onValidStateChange = config.onValidStateChange;
        this.widgetRendered = false;
        this.popupRendered = false;
    }
    async renderWidget() {
        if (!this.widget) return;
        this.widgetRendered ? console.error('Notabene: Widget is already rendered') : await this.widget.render(this.config.container);
    }
    async renderPopup() {
        if (!this.popup) return;
        this.popupRendered ? this.popup.show() : await this.popup.render(this.config.container);
    }
    setTransaction(tx) {
        const validProperties = [
            'transactionAsset',
            'transactionAmount',
            'beneficiaryAccountNumber',
            'beneficiaryAccountNumber',
            'originatorVASPdid',
            'originatorDid',
            'transactionBlockchainInfo',
            'beneficiaryVASPname',
            'beneficiaryName',
            'beneficiaryDid',
            'isNonCustodial',
            'originatorEqualsBeneficiary',
            'beneficiaryProof',
            'isValid',
            'errors', 
        ];
        Object.keys(tx).forEach((key)=>{
            if (!validProperties.includes(key)) throw new Error(`Notabene: Invalid transaction property ${key}`);
        });
        this.tx = tx;
        this.widget.updateProps({
            transaction: tx
        });
        this.popup.updateProps({
            transaction: tx
        });
    }
    getWidgetUrl() {
        const url = new URL(this.config.widget);
        url.hash = `authToken=${this.config.authToken}`;
        return url.toString();
    }
    getAdditionalInfoUrl() {
        const url = new URL(this.config.widget);
        url.search = 'popup=true';
        url.hash = `authToken=${this.config.authToken}`;
        return url.toString();
    }
    buildWidget() {
        if (!this.config.authToken) {
            console.error('Notabene: authToken is required');
            return;
        }
        const builtWidget = ($parcel$interopDefault($4mxld$zoid)).create({
            tag: 'widget',
            url: this.getWidgetUrl(),
            dimensions: {
                width: '440px',
                height: '280px'
            },
            props: {
                transaction: {
                    type: 'object',
                    required: false
                },
                onRequireAdditionalInformation: {
                    type: 'function'
                },
                onValidStateChange: {
                    type: 'function'
                },
                storeTransaction: {
                    type: 'function'
                },
                theme: {
                    type: 'object',
                    required: false
                },
                dictionary: {
                    type: 'object',
                    required: false
                }
            }
        })({
            transaction: {},
            theme: this.theme,
            dictionary: this.dictionary,
            onRequireAdditionalInformation: ()=>{
                this.renderPopup();
            },
            onValidStateChange: (isValid)=>{
                this.onValidStateChange(isValid);
            },
            storeTransaction: (tx)=>{
                this.setTransaction(tx);
            }
        });
        builtWidget.event.on(($parcel$interopDefault($4mxld$zoid)).EVENT.RENDERED, (err)=>{
            this.widgetRendered = true;
        });
        return builtWidget;
    }
    buildPopup() {
        if (!this.config.authToken) {
            console.error('Notabene: authToken is required');
            return;
        }
        const builtPopup = ($parcel$interopDefault($4mxld$zoid)).create({
            tag: 'popup',
            url: this.getAdditionalInfoUrl(),
            children: ()=>{
                return {
                    Transaction: this.tx
                };
            },
            dimensions: {
                width: '608px',
                height: '100%'
            },
            props: {
                transaction: {
                    type: 'object',
                    required: false
                },
                storeTransaction: {
                    type: 'function'
                },
                close: {
                    type: 'function'
                },
                theme: {
                    type: 'object',
                    required: false
                },
                dictionary: {
                    type: 'object',
                    required: false
                }
            },
            containerTemplate: ({ uid: uid , doc: doc , frame: frame , prerenderFrame: prerenderFrame  })=>{
                return $4mxld$jsxpragmatic.node('div', {
                    id: uid,
                    class: 'nb-container'
                }, $4mxld$jsxpragmatic.node('style', null, `
            #${uid}.container {
                border: 5px solid red;
            }
            .nb-overlay {
              position: fixed;
              width: 100vw;
              height: 100vh;
              top: 0;
              left: 0;
              display: flex;
              align-items: center;
              justify-content: center;
              background-color: rgba(0,0,0,0.5);
            }
            .nb-popup {
              max-width: 608px;
              width: 100%;
              height: 100%;
            }
            .nb-preloader {
              display: none;
            }
          `), $4mxld$jsxpragmatic.node('div', {
                    class: 'nb-overlay'
                }, $4mxld$jsxpragmatic.node('node', {
                    el: frame,
                    class: 'nb-popup'
                }), $4mxld$jsxpragmatic.node('node', {
                    el: prerenderFrame,
                    class: 'nb-preloader'
                }))).render($4mxld$jsxpragmatic.dom({
                    doc: doc
                }));
            }
        })({
            transaction: this.tx,
            storeTransaction: (tx)=>{
                this.setTransaction(tx);
                console.debug('Notabene: Transaction stored');
            },
            close: ()=>{
                this.popup.close();
                console.debug('Notabene: Popup closing');
            },
            theme: this.theme,
            dictionary: this.dictionary
        });
        builtPopup.event.on(($parcel$interopDefault($4mxld$zoid)).EVENT.RENDERED, (err)=>{
            this.popupRendered = true;
        });
        return builtPopup;
    }
}
window.Notabene = $fef5d623a19b12b5$export$2e2bcd8739ae039;




